%%
%% This is file `liuthesis.cls',
%% generated with the docstrip utility.
%%
%% The original source files were:
%%
%% liuthesis.dtx  (with options: `class')
%% 
%% IMPORTANT NOTICE:
%% 
%% For the copyright see the source file.
%% 
%% Any modified versions of this file must be renamed
%% with new filenames distinct from liuthesis.cls.
%% 
%% For distribution of the original source see the terms
%% for copying and modification in the file liuthesis.dtx.
%% 
%% This generated file may be distributed as long as the
%% original source files, as listed above, are part of the
%% same distribution. (The sources need not necessarily be
%% in the same archive or directory.)
\ProvidesClass{liuthesis}[2004/11/12 liuthesis Class v. 0.90b]
\NeedsTeXFormat{LaTeX2e}

%%\RequirePackage{lmodern}
\RequirePackage[T1]{fontenc}
\RequirePackage[latin1]{inputenc}
\RequirePackage{babel}
\RequirePackage{theorem}
\newcommand*{\liuthesisDefinition}[2]{%
  \ClassInfo{liuthesis}{Loaded definition file '\CurrentOption.ltd'}%
  \newcommand*{\thesis@divTAG}{#1}%
  \newcommand*{\@address}{#2}}

\newif\ifliuthesis@hyperref
\liuthesis@hyperreffalse
\newcommand*{\phantomsection}{\relax}
\newcommand*{\href}[2][]{#1}


%%%%%%%%%%%%%%%%%%%%%
%%%   Language    %%%
%%%%%%%%%%%%%%%%%%%%%

\DeclareOption{english}{%
  \def\acknowledgementsname{Acknowledgements}%
  \def\corollaryname{Corollary}
  \def\definitionname{Definition}
  \def\examplename{Example}
  \def\lemmaname{Lemma}
  \def\listexamplename{List of Examples}
  \def\theoremname{Theorem}
  \newcommand*{\monthName}[1]{\ifcase#1\or
    January\or February\or March\or
    April\or May\or June\or
    July\or August\or September\or
    October\or November\or December\fi}
}

\DeclareOption{swedish}{%
  \def\acknowledgementsname{Tack}%
  \def\corollaryname{Korrolarium}
  \def\definitionname{Definition}
  \def\examplename{Exempel}
  \def\lemmaname{Lemma}
  \def\listexamplename{Exempellista}
  \def\theoremname{Sats}
  \newcommand*{\monthName}[1]{\ifcase#1\or
    januari\or februari\or mars\or
    april\or maj\or juni\or
    juli\or augusti\or september\or
    oktober\or november\or december\fi}
}

%%%%%%%%%%%%%%%%%%%%%
%%% CROP SETTINGS %%%
%%%%%%%%%%%%%%%%%%%%%

\newcommand*{\@ul}{\relax}\newcommand*{\@ur}{\relax}%
\newcommand*{\@ll}{\relax}\newcommand*{\@lr}{\relax}%
\newcommand*{\@info}{\relax}%
\DeclareOption{crop}{% To get cropmarks
  \renewcommand*{\@ul}{\begin{picture}(0,0)%
      \unitlength1mm%
      \thinlines%
      \put(0,0){\line(-5,0){2}}%
      \put(0,0){\line(0,5){2}}%
    \end{picture}}%
  \renewcommand*{\@ur}{\begin{picture}(0,0)%
      \unitlength1mm%
      \thinlines%
      \put(0,0){\line(5,0){2}}%
      \put(0,0){\line(0,5){2}}%
    \end{picture}}%
  \renewcommand*{\@ll}{\begin{picture}(0,0)%
      \unitlength1mm%
      \thinlines%
      \put(0,0){\line(-5,0){2}}%
      \put(0,0){\line(0,-5){2}}%
    \end{picture}}%
  \renewcommand*{\@lr}{\begin{picture}(0,0)%
    \unitlength1mm%
    \thinlines%
    \put(0,0){\line(5,0){2}}%
    \put(0,0){\line(0,-5){2}}%
  \end{picture}}%
\PassOptionsToPackage{axes}{crop}}

\DeclareOption{info}{%
  \renewcommand*{\@info}{{%
    \global\advance\CROP@index\@ne%
    \addtolength{\paperwidth}{-20\p@}%
    \makebox[\z@]{%
      \hss%
      \raise10\p@\vbox to\z@ {
        \centering%
        \hsize\paperwidth %
        \vss%
        \normalfont%
        \let\protect\relax%
        \CROP@font{%
          \texttt{\jobname}:~\the\year-\the\month-\the\day\:\:%
          \CROP@time\quad---\quad\thepage(\the\CROP@index)\strut%
        }%
        \vspace*{25\p@}
      }%
      \hss%
    }
  }}%
}

\DeclareOption{noCrop}{%
  \renewcommand*{\@ul}{\relax}\renewcommand*{\@ur}{\relax}%
  \renewcommand*{\@ll}{\relax}\renewcommand*{\@lr}{\relax}%
  \renewcommand*{\@info}{\relax}%
}


%%%%%%%%%%%%%%%%%%%%%
%%%  PAGE LAYOUT  %%%
%%%%%%%%%%%%%%%%%%%%%
\newcommand*{\useHyperRef}{%
  \liuthesis@hyperreftrue%
  \usepackage{hyperref}[2000/09/29]}
\PassOptionsToPackage{off, a4, center}{crop} % s5 centered on a4 with crops
\DeclareOption{print}{% s5 format
  \PassOptionsToPackage{off, noaxes, width=165mm, height=240mm}{crop}%
  \ExecuteOptions{noCrop}%
}

\DeclareOption{pdfRelease}{% Release in pdf format without copyright notice
  \PassOptionsToPackage{off, noaxes, a4, center}{crop}%
  \ExecuteOptions{noCrop}%
  \renewcommand*{\useHyperRef}{%
    \liuthesis@hyperreftrue%
    \usepackage[ps2pdf, hyperindex, bookmarks]{hyperref}[2000/09/29]}
}

\DeclareOption{ePress}{% s5 centered on a4
  \AtEndDocument{\cleardoublepage\makeCopyright}%
  \ExecuteOptions{pdfRelease}%
}

\DeclareOption{draft}{% s5 centered on a4 DRAFT
  \PassOptionsToPackage{off, a4, center}{crop} % s5 centered on a4 with crops
  \ClassInfo{liuthesis}{This is a DRAFT mode and should hence NOT be
    used for other purposes. Pictures are blank and overful hboxes
    stand out.}
}
\AtEndOfClass{%
  \setlength{\marginparwidth}{\oddsidemargin}%
  \addtolength{\marginparwidth}{-\marginparsep}%
  \addtolength{\marginparwidth}{-\p@}%
}
\DeclareOption*{\InputIfFileExists{\CurrentOption.ltd}
  {}{\PassOptionsToClass{\CurrentOption}{book}\OptionNotUsed}}
\ProcessOptions\relax

\ifx\thesis@divTAG\relax
  \ClassError{liuthesis}{No division definition found.}
\else
  \ClassInfo{liuthesis}{Loading division definition \thesis@divTAG.}
\fi

\LoadClass[twoside]{book}
\DeclareRobustCommand\em%
        {\@nomath\em \ifdim \fontdimen\@ne\font >\z@
                       \upshape \else \slshape \fi}
\RequirePackage{graphicx}
\RequirePackage[dvips=false, pdftex=false, vtex=false,%
  twoside, papersize={165mm,240mm}, body={125mm,195mm},%
  bindingoffset=4mm, marginparsep=3mm, portrait,%
  twocolumn=false, vmarginratio={4:5}]{geometry}[2002/07/08]

\RequirePackage{crop}[2001/11/16]
\RequirePackage[intlimits]{amsmath}
\RequirePackage{amsfonts, amssymb}
\cropdef[\@info]{\@ul}{\@ur}{\@ll}{\@lr}{liuthesiscrop}
\crop[liuthesiscrop,font=\mdseries\upshape\scriptsize]
\newcommand*{\ifLanguageInUse}[1]{%
  \expandafter\ifx\csname l@#1\endcsname\relax
  \expandafter\@secondoftwo
  \else
  \bbl@afterfi{\ifnum\csname l@#1\endcsname=\language
    \expandafter\@firstoftwo
    \else
    \expandafter\@secondoftwo
    \fi}%
  \fi}

%%%%%%%%%%%%%%%%%%%%%%%%
%%        Info        %%
%%%%%%%%%%%%%%%%%%%%%%%%

\renewcommand*{\author}[1]{\renewcommand*{\@author}{#1}%
  \ifliuthesis@hyperref\hypersetup{pdfauthor={#1}}\fi}%
\newcommand*{\thesis@day}{%
  \@latex@warning@no@line{No \noexpand\thesisDate given}}%
\newcommand*{\thesisDate}[3]{%
  \newcommand*{\thesis@month}{#1}%
  \renewcommand*{\thesis@day}{#2}%
  \newcommand*{\thesis@year}{#3}%
}
\newcommand*{\thesis@division}{%
  \@latex@warning@no@line{No \noexpand\thesisDivision given}}%
\newcommand*{\thesisDivision}[1]{\renewcommand*{\thesis@division}{#1}}%
\newcommand*{\thesis@subject}{%
  \@latex@warning@no@line{No \noexpand\subject given}}%
\newcommand*{\subject}[1]{\renewcommand*{\thesis@subject}{#1}%
  \ifliuthesis@hyperref\hypersetup{pdfsubject={#1}}\fi}%
\newcommand*{\thesis@No}{%
  \@latex@warning@no@line{No \noexpand\thesisNo given}}%
\newcommand*{\thesisNo}[1]{\renewcommand*{\thesis@No}{#1}}%
\renewcommand*{\title}[2]{\newcommand*{\swe@title}{#1}%
  \renewcommand*{\@title}{#2}%
  \ifliuthesis@hyperref%
  \ifLanguageInUse{swedish}{\hypersetup{pdftitle={#1}}}%
  {\hypersetup{pdftitle={#2}}}\fi}%
\newcommand*{\URL@b}{\@latex@warning@no@line{No \noexpand\URL given}}%
\newcommand*{\URL@a}{}%
\newcommand*{\URL}[2][]{\renewcommand*{\URL@a}{#1}\renewcommand*{\URL@b}{#2}}%
\newcommand*{\keywords}[1]{\newcommand*{\@keywords}{#1}%
  \ifliuthesis@hyperref\hypersetup{pdfkeywords={#1}}\fi}%
\newcommand{\@abstract}{\@latex@warning@no@line{No \noexpand\abstract given}}%
\newcommand{\abstract}[2][]{%
  \renewcommand{\@abstract}{\ignorespacesafterend\noindent #2\unskip}%
  \newcommand{\swe@abstract}{\ignorespacesafterend\noindent #1\unskip}}%
\newcommand{\@acknowledgements}{%
  \@latex@warning@no@line{No \noexpand\acknowledgements given}}%
\newcommand{\acknowledgements}[1]{%
  \renewcommand{\@acknowledgements}{\ignorespacesafterend\noindent#1\unskip}}%
\newcommand*{\@supervisor}{\@latex@warning@no@line{No \noexpand\supervisor given}}%
\newcommand*{\supervisor}[1]{\renewcommand{\@supervisor}{\ignorespaces#1\ignorespaces}}%
\newcommand*{\@examiner}{\@latex@warning@no@line{No \noexpand\examiner given}}%
\newcommand*{\examiner}[1]{\renewcommand{\@examiner}{\ignorespaces#1\ignorespaces}}
\newcommand*{\AND}{\\\>\bfseries\ignorespaces}%
\newcommand*{\AT}{\\\>\>\small\ignorespaces}%

%%%%%%%%%%%%%%%%%%%%%%%%
%%    Library page    %%
%%%%%%%%%%%%%%%%%%%%%%%%

\newcommand{\makeLibraryPage}{%
  \clearpage \thispagestyle{empty}%
  \enlargethispage*{27mm} {\centering%
  \vspace*{-11mm}
  \hspace*{3mm}%
  \makebox[\z@][l]{%
    \begin{minipage}[t][212mm]{126mm}%
      \scriptsize \setlength{\unitlength}{1mm}%
      \fontsize{7}{8\p@} \selectfont%
      \begin{picture}(126,212)(0,0)%
        %% Department and division
        \put(0,190){\makebox[\z@][l]{\framebox(92,22){}}}%
        \put(1,191){\includegraphics[width=20mm]{LiTH_sigill_sv}}%
        \put(25,209){\parbox[t]{5cm}{\textbf{Avdelning, Institution}\\%
            Division, Department}}%
        \put(28,197){\parbox[c]{64mm}{\thesis@division\\\@address}}%
        %% Date
        \put(93,190){\makebox[\z@][l]{\framebox(33,22){}}}%
        \put(94,209){\parbox[t]{5cm}{\textbf{Datum}\\%
            Date}}%      % Must be Swedish style
        \put(95,197){\thesis@year-%
          \ifnum\thesis@month<10 0\fi\thesis@month-%
          \ifnum\thesis@day<10 0\fi\thesis@day}%
        %% Language
        \put(0,157){\makebox[\z@][t]{\framebox(30,32){}}}%
        \put(1,186){\parbox[t]{3cm}{\textbf{Spr^^e5k}\\Language}}%
        \put(1,178){$\Box$ Svenska/Swedish}%
        \put(1,174){$\Box$ Engelska/English}%
        \put(1,162){$\Box$} \put(5,162){\line(1,0){20}}%
        \ifLanguageInUse{swedish}{\put(1,178){$\boxtimes$}}{%
          \ifLanguageInUse{english}{\put(1,174){$\boxtimes$}}{}}%
        %% Report category
        \put(31,157){\makebox[\z@][t]{\framebox(30,32){}}}%
        \put(32,186){\parbox[t]{5cm}{\textbf{Rapporttyp}\\Report category}}%
        \put(32,178){$\Box$ Licentiatavhandling}%
        \put(32,174){$\Box$ Examensarbete}%
        \put(32,170){$\Box$ C-uppsats}%
        \put(32,166){$\Box$ D-uppsats}%
        \put(32,162){$\Box$ ^^d6vrig rapport}%
        \put(32,158){$\Box$} \put(35,158){\line(1,0){20}}%
        \put(32,174){$\boxtimes$}  % set kind of report
        %% URL
        \put(0,143){\makebox[\z@][t]{\framebox(61,13){}}}%
        \put(1,153){\textbf{URL f^^f6r elektronisk version}}%
        \put(4,148){%
          \sbox{\@tempboxa}{\mbox{\URL@a}}%
          \ifdim\wd\@tempboxa > \z@%
            \parbox[c]{58mm}{\href{\URL@a}{\texttt{\URL@a}}\\%
              \href{\URL@b}{\texttt{\URL@b}}}%
          \else%
            \parbox[c]{58mm}{\href{\URL@b}{\texttt{\URL@b}}}%
          \fi}%
        %% ISBN etc
        \put(62,143){\makebox[\z@][t]{\framebox(64,46){}}}%
        \put(63,186){\textbf{ISBN}}%
        \put(63,181){\line(1,0){62}}\put(69,182){---}%
        \put(63,178){\textbf{ISRN}}%
        \put(63,171){\line(1,0){62}} \put(70,174){\thesis@No}%
        \put(63,168){\parbox[t]{5cm}{\textbf{Serietitel och serienummer}\\%
            Title of series, numbering}}%
        \put(102,168){\textbf{ISSN}}%
        \put(102,163){\line(1,0){23}} \put(102,164){---}%
        %% Title
        \put(0,108){\makebox[\z@][t]{\framebox(126,34){}}}%
        \put(1,138){\parbox[t]{5cm}{\textbf{Titel}\\Title}}%
        \put(17,138){\parbox[t]{100mm}{\swe@title\par\smallskip\@title}}%
        \put(1,117){\parbox[t]{5cm}{\textbf{F^^f6rfattare}\\Author}}%
        \put(17,117){\@author}%
        %% Abstract
        \put(0,12){\makebox[\z@][t]{\framebox(126,95){}}}%
        \put(1,104){\parbox[t]{5cm}{\textbf{Sammanfattning}\\Abstract}}%
        \put(17,96){\parbox[t]{100mm}{\setlength{\parindent}{1.5em}\@abstract}}%
        %% Keywords
        \put(0,0){\makebox[\z@][t]{\framebox(126,11){}}}%
        \put(1,8){\parbox[t]{5cm}{\textbf{Nyckelord}\\Keywords}}%
        \put(17,5){\parbox[t]{100mm}{\@keywords}}
      \end{picture}%
    \end{minipage}%
  }}%
  \clearpage%
}

%%%%%%%%%%%%%%%%%%%%%%%%
%%  Acknowledgements  %%
%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand*{\makeAcknowledgements}{%
  \clearpage%
  \chapter*{\acknowledgementsname}%
  \@acknowledgements%
  \clearpage%
}

%%%%%%%%%%%%%%%%%%%%%%%%
%%      Abstract      %%
%%%%%%%%%%%%%%%%%%%%%%%%

\newcommand{\lt@twoAbstractPages}{}
\newcommand{\twoAbstractPage}{%
  \renewcommand{\lt@twoAbstractPages}{\cleardoublepage}}
\newcommand*{\makeAbstract}{%
  \clearpage \thispagestyle{plain}%
  \vspace*{-3\baselineskip}%
  \@makeschapterhead{Abstract}  % MIGHT CHANGE!!!
  \vspace*{-1.5\baselineskip}%
  \@abstract%
  \vfill \sbox{\@tempboxa}{\mbox{\swe@abstract}}%
  \ifdim\wd\@tempboxa > \z@%
    \lt@twoAbstractPages
    \thispagestyle{plain}
    \vspace*{-3\baselineskip}%
    \@makeschapterhead{Sammanfattning} %MIGHT CHANGE!!!
    \vspace*{-1.5\baselineskip}%
    \frenchspacing \swe@abstract \nonfrenchspacing%
  \fi%
  \vfill \clearpage%
}

%%%%%%%%%%%%%%%%%%%%%%%%
%%  Copyright notice  %%
%%%%%%%%%%%%%%%%%%%%%%%%

\newcommand*{\makeCopyright}{\begingroup%
  \clearpage \thispagestyle{empty}%
  %
  \vspace*{-22mm}%
  \noindent%
  \includegraphics[height=14mm]{epresslogo}
  \hfill%
  \includegraphics[height=18mm]{LinkUniv_staende_pms}%
  %
  \vspace{3\baselineskip} \frenchspacing%
  \par\noindent{\fontsize{12pt}{14pt}\selectfont%
    \normalfont\large\bfseries Upphovsr^^e4tt}\\[1.5ex]
  \fontsize{10pt}{12pt}\selectfont
  Detta dokument h^^e5lls tillg^^e4ngligt p^^e5 Internet --- eller dess
  framtida ers^^e4ttare --- under 25 ^^e5r fr^^e5n publiceringsdatum under
  f^^f6ruts^^e4ttning att inga extraordin^^e4ra omst^^e4ndigheter uppst^^e5r.
  \par
  Tillg^^e5ng till dokumentet inneb^^e4r tillst^^e5nd f^^f6r var och en att l^^e4sa,
  ladda ner, skriva ut enstaka kopior f^^f6r enskilt bruk och att anv^^e4nda
  det of^^f6r^^e4ndrat f^^f6r icke\-kommersiell forskning och f^^f6r undervisning.
  ^^d6verf^^f6ring av upphovsr^^e4tten vid en senare tidpunkt kan inte
  upph^^e4va detta tillst^^e5nd. All annan anv^^e4ndning av dokumentet kr^^e4ver
  upphovsmannens medgivande. F^^f6r att garantera ^^e4ktheten, s^^e4kerheten
  och tillg^^e4ngligheten finns det l^^f6sningar av teknisk och
  administrativ art.
  \par
  Upphovsmannens ideella r^^e4tt innefattar r^^e4tt att bli n^^e4mnd som
  upphovsman i den omfattning som god sed kr^^e4ver vid anv^^e4ndning av
  dokumentet p^^e5 ovan be\-skrivna s^^e4tt samt skydd mot att dokumentet
  ^^e4ndras eller presenteras i s^^e5dan form eller i s^^e5dant sammanhang som
  ^^e4r kr^^e4nkande f^^f6r upphovsmannens litter^^e4ra eller konstn^^e4rliga
  anseende eller egenart.
  \par
  F^^f6r ytterligare information om Link^^f6ping University Electronic Press
  se f^^f6rlagets hemsida
  \href{http://www.ep.liu.se/}{\texttt{http://www.ep.liu.se/}}
  \nonfrenchspacing
  %
  \vspace*{4\baselineskip}
  \par\noindent{\fontsize{12pt}{14pt}\selectfont%
    \normalfont\large\bfseries Copyright}\\[1.5ex]
  \fontsize{10pt}{12pt}\selectfont
  The publishers will keep this document online on the Internet --- or
  its possible replacement --- for a period of 25 years from the date
  of publication barring exceptional circumstances.
  \par
  The online availability of the document implies a permanent permission
  for anyone to read, to download, to print out single copies for your
  own use and to use it unchanged for any non-commercial research and
  educational purpose. Subsequent transfers of copyright cannot revoke
  this permission. All other uses of the document are conditional on the
  consent of the copyright owner. The publisher has taken technical and
  administrative measures to assure authenticity, security and
  accessibility.
  \par
  According to intellectual property law the author has the right to
  be men\-tioned when his/her work is accessed as described above and to
  be protected against infringement.
  \par
  For additional information about the Link^^f6ping University Electronic
  Press and its procedures for publication and for assurance of
  document integrity, please refer to its www home page:
  \href{http://www.ep.liu.se/}{\texttt{http://www.ep.liu.se/}} \par
       {\vspace*{\baselineskip} \flushright \copyright\ \@author
  \clearpage} \endgroup
}

%%%%%%%%%%%%%%%%%%%%%%%%
%%    Environments    %%
%%%%%%%%%%%%%%%%%%%%%%%%

\theorembodyfont{\normalfont\slshape}
\newtheorem{theorem}{\theoremname}[chapter]
\newtheorem{lemma}{\lemmaname}[chapter]
\newtheorem{definition}{\definitionname}[chapter]
\newtheorem{corollary}{\corollaryname}[chapter]

%%% Proof%%%
\newenvironment{proof}[1][]{
    \sbox{\@tempboxa}{\mbox{#1}}%
    \par\noindent%
    \ifdim\wd\@tempboxa > \z@%
      \textbf{\proofname~(#1)}%
    \else%
      \textbf{\proofname}%
    \fi%
    \begingroup\small%
  }%
  {%
    \endgroup%
    \hspace*{\stretch{ 1}}$\Box$\par\bigskip%
    \ignorespacesafterend%
}

%%% Example %%%
\DeclareRobustCommand*{\listofexamples}{%
  \section*{\listexamplename}%
  \@starttoc{xmp}%
}
\newcommand*{\l@example}{\l@figure}%
\newcounter{Example}[chapter]%
\renewcommand*{\theExample}{\thechapter.\arabic{Example}}%
\newenvironment{example}[1][]{%
  \refstepcounter{Example}%
  \sbox{\@tempboxa}{\ignorespaces#1\unskip}%
  \ifdim \wd\@tempboxa>\z@%
    \sbox{\@tempboxa}{\textbf{%
        \thinspace\ignorespaces\examplename\unskip~\theExample:~#1\thinspace}}%
  \else%
    \sbox{\@tempboxa}{\textbf{\thinspace\examplename~\theExample\thinspace}}%
  \fi%
  \addcontentsline{xmp}{example}{\protect\numberline{\theExample}#1}%
  \setlength{\@tempskipa}{\textwidth}%
  \addtolength{\@tempskipa}{-\wd\@tempboxa}
  \addtolength{\@tempskipa}{-1em}%
  \pagebreak[0]%
  \strut\\[.5\baselineskip]%
  \hspace*{-\p@}\hspace*{-.5em}%
  \rule[\p@]{\p@}{1ex}\rule[1ex]{2em}{\p@}%
  \raisebox{.5ex}{\box\@tempboxa}%
  \rule[1ex]{\@tempskipa}{\p@}\rule[\p@]{\p@}{1ex}%
  \hspace*{-\p@}\hspace*{-.5em}%
  \newline\begingroup\ignorespaces%
  \ignorespacesafterend%
}%
{%
  \unskip\endgroup\strut\newline%
  \hspace*{-\p@}\hspace*{-.5em}%
  \rule{1\p@}{1ex}\rule{\textwidth}{\p@}\rule{1em}{\p@}\rule{\p@}{1ex}%
  \hspace*{-\p@}\hspace*{-.5em}\\[.5\baselineskip]%
  \pagebreak[0]%
  \ignorespacesafterend%
}

%%%%%%%%%%%%%%%%%%%%%%%%
%%      Headings      %%
%%%%%%%%%%%%%%%%%%%%%%%%

\DeclareRobustCommand*{\chaptermark}[1]{\markboth{#1}{}}
\DeclareRobustCommand*{\sectionmark}[1]{\markright{\thesection~#1}{}}
\renewcommand*{\ps@headings}{%
  \renewcommand*{\@oddfoot}{}%
  \renewcommand*{\@evenfoot}{}%
  \renewcommand*{\@evenhead}{%
    \setlength{\@tempskipa}{\textwidth}%
    \addtolength{\@tempskipa}{-.25em}%
    \parbox{\@tempskipa}{\bfseries \thepage\hfill\ \ \leftmark%
      \vspace*{2\p@}\hrule}}%
  \renewcommand*{\@oddhead}{%
    \setlength{\@tempskipa}{\textwidth}%
    \addtolength{\@tempskipa}{-.25em}%
    \parbox{\@tempskipa}{\bfseries\rightmark\hfill\ \ \thepage
      \vspace*{2\p@}\hrule}%
}}

%%%%%%%%%%%%%%%%%%%%%%%%
%%    Bibliography    %%
%%%%%%%%%%%%%%%%%%%%%%%%

\renewenvironment{thebibliography}[1]{%
  \chapter*{\bibname}%
  \phantomsection\addcontentsline{toc}{chapter}{\bibname}%
  \markboth{\bibname}{\bibname}%
  \list{\@biblabel{\@arabic\c@enumiv}}%
  {\settowidth{\labelwidth}{\@biblabel{#1}}%
            \setlength{\leftmargin}{\labelwidth}%
            \addtolength{\leftmargin}{\labelsep}%
            \@openbib@code%
            \usecounter{enumiv}%
            \let\p@enumiv\@empty%
            \renewcommand\theenumiv{\@arabic\c@enumiv}}%
      \sloppy%
      \clubpenalty4000%
      \@clubpenalty \clubpenalty%
      \widowpenalty4000%
      \sfcode`\.\@m}%
{\def\@noitemerr%
  {\@latex@warning{Empty `thebibliography' environment}}%
  \endlist}%

%%%%%%%%%%%%%%%%%%%%%%%%
%%       Index        %%
%%%%%%%%%%%%%%%%%%%%%%%%

\renewenvironment{theindex}
               {\if@twocolumn
                  \@restonecolfalse
                \else
                  \@restonecoltrue
                \fi
                \columnseprule \z@
                \columnsep 35\p@
                \twocolumn[\@makeschapterhead{\indexname}]%
                \phantomsection\addcontentsline{toc}{chapter}{\indexname}%
                \markboth{\indexname}{\indexname}%
                \thispagestyle{plain}\setlength{\parindent}{\z@}%
                \setlength{\parskip}{\z@ \@plus .3\p@}%
                \let\item\@idxitem}%
               {\if@restonecol\onecolumn\else\clearpage\fi}

%%%%%%%%%%%%%%%%%%%%%%%%
%%     Sectioning     %%
%%%%%%%%%%%%%%%%%%%%%%%%

\renewcommand{\frontmatter}{%
  \thispagestyle{empty}%
  \cleardoublepage%
  \@mainmatterfalse%
  \pagenumbering{roman}}
\renewcommand{\mainmatter}{%
  \thispagestyle{empty}%
  \cleardoublepage%
  \pagestyle{headings}
  \@mainmattertrue%
  \pagenumbering{arabic}}
\renewcommand*{\backmatter}{%
  \if@openright%
    \cleardoublepage%
  \else%
    \clearpage%
  \fi%
  \@openrightfalse}
\newcommand{\makeFrontMatter}[1][]{%
  \makeFrontPage \thispagestyle{empty} \cleardoublepage%
  \frontmatter \makeTitlePage \thispagestyle{empty} \cleardoublepage%
  \makeLibraryPage \thispagestyle{empty} \cleardoublepage%
  \pagestyle{headings} \makeAbstract \thispagestyle{empty} \cleardoublepage%
  \makeAcknowledgements \thispagestyle{empty} \cleardoublepage%
  \tableofcontents
  #1 \mainmatter%
}

%%%%%%%%%%%%%%%%%%%%%%%%
%%       Other        %%
%%%%%%%%%%%%%%%%%%%%%%%%

\DeclareRobustCommand*{\tableofcontents}{%
  \chapter*{\contentsname\markboth{\contentsname}{\contentsname}}%
  \@starttoc{toc}%
}
\DeclareRobustCommand*{\listoffigures}{%
  \section*{\listfigurename}%
  \@starttoc{lof}%
}
\DeclareRobustCommand*{\listoftables}{%
  \section*{\listtablename}%
  \@starttoc{lot}%
}

\renewcommand{\@makecaption}[2]{%
  \vspace{\abovecaptionskip}
  \begin{small}
    \sbox{\@tempboxa}{\textbf{#1.} #2}
    \ifdim \wd\@tempboxa > \hsize
      \textbf{#1.} #2\par
    \else
      \global \@minipagefalse
      \parbox{\hsize}{\centering \usebox{\@tempboxa}\hfil}
    \fi
  \end{small}
  \vspace{\belowcaptionskip}
}

\renewcommand{\footnoterule}{\vspace*{-3\p@}
  \noindent\rule{.5\textwidth}{.5\p@}\vspace*{2.6\p@}
}

%% \CharacterTable
%%  {Upper-case    \A\B\C\D\E\F\G\H\I\J\K\L\M\N\O\P\Q\R\S\T\U\V\W\X\Y\Z
%%   Lower-case    \a\b\c\d\e\f\g\h\i\j\k\l\m\n\o\p\q\r\s\t\u\v\w\x\y\z
%%   Digits        \0\1\2\3\4\5\6\7\8\9
%%   Exclamation   \!     Double quote  \"     Hash (number) \#
%%   Dollar        \$     Percent       \%     Ampersand     \&
%%   Acute accent  \'     Left paren    \(     Right paren   \)
%%   Asterisk      \*     Plus          \+     Comma         \,
%%   Minus         \-     Point         \.     Solidus       \/
%%   Colon         \:     Semicolon     \;     Less than     \<
%%   Equals        \=     Greater than  \>     Question mark \?
%%   Commercial at \@     Left bracket  \[     Backslash     \\
%%   Right bracket \]     Circumflex    \^     Underscore    \_
%%   Grave accent  \`     Left brace    \{     Vertical bar  \|
%%   Right brace   \}     Tilde         \~}
\endinput
%%
%% End of file `liuthesis.cls'.
