holds(and(F1, F2), S) :- holds(F1,S), holds(F2,S).
holds(or(F1, F2), S) :- holds(F1,S).
holds(or(F1, F2), S) :- holds(F2,S).
holds(not(F1), S) :- \+ holds(F1,S).
holds(xor(F1,F2),S) :- holds(F1,S), \+ holds(F2,S).
holds(xor(F1,F2),S) :- holds(F2,S), \+ holds(F1,S).
 
holds(eg(F), S) :- holds(not(af(not(F))), S).
holds(ex(F), S1) :- step(S1,[S21,S22,S23,S24,S25]), holds(F,[S21,S22,S23,S24,S25]).
holds(eu(F, G), S) :- holds(G,S).
holds(eu(F, G), S) :- holds(F, S), holds(ex(eu(F, G)), S).
 
holds(ax(F), S) :- holds(not(ex(not(F))), S).
holds(ef(F), S) :- holds(eu(true, F), S).
holds(af(F), S) :- holds(F, S).
holds(af(F), S) :- holds(ax(af(F)), S).
holds(ag(F), S) :- holds(not(ef(not(F))), S).
holds(au(F1, F2), S) :- holds(and(not(eu(not(F2), and(not(F1), not(F2)))),
  not(eg(not(F2)))), S).

holds(true, S).

holds(init, [S1, S2, S3, S4, S5]).
holds(crit1, [S1,S2,S3,S4,S5]) :- sat(S1).
holds(crit2, [S1,S2,S3,S4,S5]) :- sat(S2).
holds(crit3, [S1,S2,S3,S4,S5]) :- sat(S3).
holds(crit4, [S1,S2,S3,S4,S5]) :- sat(S4).
holds(crit5, [S1,S2,S3,S4,S5]) :- sat(S5).

holds(doublecrit, [S1, S2, S3, S4, S5]) :-
   holds(or(or(or(and(crit1,crit2), or(and(crit1,crit3), and(crit1,crit4))),
               or(and(crit1,crit5), and(crit2,crit3))),
            or(or(and(crit2,crit4), or(and(crit2,crit5), and(crit3,crit4))),
               or(and(crit3,crit5), and(crit4,crit5)))), [S1, S2, S3, S4, S5]).

step([S1, S2, S3, S4, S5], [T1, T2, T3, T4, T5]) :-
  action([S1,T1,T2,T3,T4,T5]), action([S2,T2,T1,T3,T4,T5]), action([S3,T3,T1,T2,T4,T5]),
  action([S4,T4,T1,T2,T3,T5]), action([S5,T5,T1,T2,T3,T4]).

action([S, T, TT1, TT2, TT3, TT4]) :- sat(or(and(not(S),not(T)),
                                          or(and(not(S), and(not(TT1), and(not(TT2), and(not(TT3), and(not(TT4), T))))),
                                          S))).

spec([S1, S2, S3, S4, S5]) :- holds(ag(not(doublecrit)), [S1,S2,S3,S4,S5]).

query([S1, S2, S3, S4, S5]) :- holds(init, [S1, S2, S3, S4, S5]), spec([S1, S2, S3, S4, S5]).
