%{

#include <cstring>
#include <vector>
#include <sstream>

#include "parser.tab.hpp"

#include "stringsholder.hpp"

using namespace std;

StringsHolder stringsholder;

%}

%option noyywrap
%option nounput
%option outfile="scanner.cpp"

ID [a-z][A-Z_a-z0-9]*
VAR [A-Z][A-Za-z_0-9]*

%%

{ID} {
  yylval.t_string = stringsholder.add(yytext);
  return T_ID;
}

{VAR} {
  yylval.t_string = stringsholder.add(yytext);
  return T_VAR;
}

"(" return T_LPAREN;

")" return T_RPAREN;

":-" return T_IF;

"," return T_COMMA;

"." return T_DOT;

"[" return T_LBRACKET;

"]" return T_RBRACKET;

"|" return T_PIPE;

"\\+" return T_NEG;

.|\n // ignore anything else

%%
